<!doctype html>
<html class="no-js">
<head>



<meta charset="utf-8">
<title>Learn Python the Hard Way</title>

<meta http-equiv="X-UA-Compatible" content="IE=edge">
<meta name="description" content="">
<meta name="viewport" content="width=device-width,initial-scale=1">

<link href='https://fonts.googleapis.com/css?family=Source+Code+Pro|Source+Sans+Pro:200,400,700,200italic,400italic,700italic' rel='stylesheet' type='text/css'>
<link href="../css/style.min.css" rel="stylesheet">
<!-- http://www.socicon.com -->
<link href="../css/icons.css" rel="stylesheet">


</head>

<body class="baseline-grid-off book-site" id="top">




<header class="header" role="banner">
    <nav class="navbar navbar-full nav-brand-family">
        <div class="row middle-xs">
            <ul class="brand-links show-md col-xs-3 col-sm-10 bare">
                <li><a href="https://learncodethehardway.org" class="waves-effect">Learn:</a></li>

                <li><a href="https://learncodethehardway.org/python/" class="waves-effect active">Python</a></li>

                <li><a href="https://learncodethehardway.org/ruby/" class="waves-effect">Ruby</a></li>

                <li><a href="https://learncodethehardway.org/more-python/" class="waves-effect">More Python</a></li>

                <li><a href="https://learncodethehardway.org/c/" class="waves-effect">C</a></li>

                <li><a href="https://learncodethehardway.org/sql/" class="waves-effect">SQL</a></li>

                <li><a href="https://learncodethehardway.org/javascript/" class="waves-effect">Javascript</a></li>

                <li><a href="https://learncodethehardway.org/unix/" class="waves-effect">Unix</a></li>

                <li><a href="https://learncodethehardway.org/regex/" class="waves-effect">RegEx</a></li>

                <li><a href="https://www.learndesignthehardway.com/" class="waves-effect">Design</a></li>

            </ul>
            <ul class="brand-links hide-md col-xs-3 col-sm-10 bare">
                <li><a href="https://learncodethehardway.org/" class="waves-effect">LCTHW</a></li>
            </ul>

            <ul class="site-meta col-xs-9 col-sm-2 end-xs bare">
                <li><a href="https://shop.learncodethehardway.org/access/reactivate/" class="waves-effect"><i class="icon icon-user"></i> Login</a></li>
            </ul>

        </div>
    </nav>

    <nav class="navbar navbar-full nav-main" role="navigation">
        <div class="row between-xs center-xs middle-xs bare">
            <div class="col-xs-4 start-xs bare">
                <a href="ex52.html#" class="no-underline nav-trigger waves-effect" id="toc"><div class="transformer hamburcloser">
                        <div class="bar bar-t"></div>
                        <div class="bar bar-m-a"></div>
                        <div class="bar bar-m-b"></div>
                        <div class="bar bar-b"></div>
                </div><span class="nav-trigger_text show-sm-inline">Contents</span></a>
            </div>
            <div class="col-xs-4"><strong>&nbsp;</strong></div>
            <div class="col-xs-4 end-xs bare">
                <a href="https://helpthw.zendesk.com/hc/en-us" class="no-underline nav-trigger waves-effect" id="help"><div class="transformer questioncloser">
                        <div class="icon-question-mark"></div>
                </div><span class="nav-trigger_text show-sm-inline">Help</span></a>
            </div>
        </div>
    </nav>

</header>




<div class="wrapper">
    <div class="masthead python-background" style="background-image: url('/images/pattern-python.svg')">
        <img src="../images/logo-python.svg" alt="Learn Python The Hard Way" class="logo">
    </div>

    <aside class="sidebar sidebar-left" role="complementary">
        <nav class="side-nav-container">
            <ol class="table-of-contents">
                <h3>Table of Contents</h3>
                <li><a href="preface.html">Preface</a></li>
                <li><a href="intro.html">The Hard Way Is Easier</a></li>
                <li><a href="ex0.html">Ex0: The Setup</a></li>
                <li><a href="ex1.html">Ex1: A Good First Program</a></li>
                <li><a href="ex2.html">Ex2: Comments And Pound Characters</a></li>
                <li><a href="ex3.html">Ex3: Numbers And Math</a></li>
                <li><a href="ex4.html">Ex4: Variables And Names</a></li>
                <li><a href="ex5.html">Ex5: More Variables And Printing</a></li>
                <li><a href="ex6.html">Ex6: Strings And Text</a></li>
                <li><a href="ex7.html">Ex7: More Printing</a></li>
                <li><a href="ex8.html">Ex8: Printing, Printing</a></li>
                <li><a href="ex9.html">Ex9: Printing, Printing, Printing</a></li>
                <li><a href="ex10.html">Ex10: What Was That?</a></li>
                <li><a href="ex11.html">Ex11: Asking Questions</a></li>
                <li><a href="ex12.html">Ex12: Prompting People</a></li>
                <li><a href="ex13.html">Ex13: Parameters, Unpacking, Variables</a></li>
                <li><a href="ex14.html">Ex14: Prompting And Passing</a></li>
                <li><a href="ex15.html">Ex15: Reading Files</a></li>
                <li><a href="ex16.html">Ex16: Reading And Writing Files</a></li>
                <li><a href="ex17.html">Ex17: More Files</a></li>
                <li><a href="ex18.html">Ex18: Names, Variables, Code, Functions</a></li>
                <li><a href="ex19.html">Ex19: Functions And Variables</a></li>
                <li><a href="ex20.html">Ex20: Functions And Files</a></li>
                <li><a href="ex21.html">Ex21: Functions Can Return Something</a></li>
                <li><a href="ex22.html">Ex22: What Do You Know So Far?</a></li>
                <li><a href="ex23.html">Ex23: Read Some Code</a></li>
                <li><a href="ex24.html">Ex24: More Practice</a></li>
                <li><a href="ex25.html">Ex25: Even More Practice</a></li>
                <li><a href="ex26.html">Ex26: Congratulations, Take A Test!</a></li>
                <li><a href="ex27.html">Ex27: Memorizing Logic</a></li>
                <li><a href="ex28.html">Ex28: Boolean Practice</a></li>
                <li><a href="ex29.html">Ex29: What If</a></li>
                <li><a href="ex30.html">Ex30: Else And If</a></li>
                <li><a href="ex31.html">Ex31: Making Decisions</a></li>
                <li><a href="ex32.html">Ex32: Loops And Lists</a></li>
                <li><a href="ex33.html">Ex33: While Loops</a></li>
                <li><a href="ex34.html">Ex34: Accessing Elements Of Lists</a></li>
                <li><a href="ex35.html">Ex35: Branches and Functions</a></li>
                <li><a href="ex36.html">Ex36: Designing and Debugging</a></li>
                <li><a href="ex37.html">Ex37: Symbol Review</a></li>
                <li><a href="ex38.html">Ex38: Doing Things To Lists</a></li>
                <li><a href="ex39.html">Ex39: Dictionaries, Oh Lovely Dictionaries</a></li>
                <li><a href="ex40.html">Ex40: Modules, Classes, And Objects</a></li>
                <li><a href="ex41.html">Ex41: Learning To Speak Object Oriented</a></li>
                <li><a href="ex42.html">Ex42: Is-A, Has-A, Objects, and Classes</a></li>
                <li><a href="ex43.html">Ex43: Gothons From Planet Percal #25</a></li>
                <li><a href="ex44.html">Ex44: Inheritance Vs. Composition</a></li>
                <li><a href="ex45.html">Ex45: You Make A Game</a></li>
                <li><a href="ex46.html">Ex46: A Project Skeleton</a></li>
                <li><a href="ex47.html">Ex47: Automated Testing</a></li>
                <li><a href="ex48.html">Ex48: Advanced User Input</a></li>
                <li><a href="ex49.html">Ex49: Making Sentences</a></li>
                <li><a href="ex50.html">Ex50: Your First Website</a></li>
                <li><a href="ex51.html">Ex51: Getting Input From A Browser</a></li>
                <li><a href="ex52.html">Ex52: The Start Of Your Web Game</a></li>
                <li><a href="advice.html">Advice From An Old Programmer</a></li>
                <li><a href="next.html">Next Steps</a></li>
                <li><a href="appendixa.html">Appendix A: Command Line Crash Course</a></li>
            </ol>
            <ul class="site-links">
                <h3>Learn the Hard Way</h3>
                <li><a href="ex52.html#" class="waves-effect"><i class="icon-information"></i> About LPTHW</a></li>
                <li><a href="ex52.html#" class="waves-effect"><i class="icon-question-mark"></i> Help &amp; Support</a></li>
                <li><a href="ex52.html#" class="waves-effect"><i class="socicon-twitter"></i> Follow us on Twitter</a></li>
            </ul>
        </nav>
        <div class="colophon text-center">
            <div class="intro">
                <p class="bare-bottom">
                The type for this book is set in 18px / 1.5
                <a href="https://www.google.com/fonts/specimen/Source+Serif+Pro">Adobe Serif</a>,
                <a href="https://www.google.com/fonts/specimen/Source+Sans+Pro">Sans</a>, and
                <a href="https://www.google.com/fonts/specimen/Source+Code+Pro">Code</a>.
                </p>
            </div>
            <div class="printers-mark">
                <div class="inscription">Docendo <i class="icon-repeat"></i> Discimus</div>
            </div>
        </div>
    </aside>

    <div class="overlay"></div>

    <main class="main python" role="main">
    <div class="main-container row center-xs">
        <div class="col-xs-11 col-sm-10 col-md-9 col-lg-8">

            <div class="content">
                <!--- RST STARTS -->
                <h1 class="title">Exercise 52: The Start Of Your Web Game</h1>
                <p>We're coming to the end of the book, and in this exercise I'm going to really challenge you.  When you're done, you'll be a reasonably competent Python beginner.  You'll still need to go through a few more books and write a couple more projects, but you'll have the skills to complete them.  The only thing in your way will be time, motivation, and resources.</p>
<p>In this exercise, we won't make a complete game, but instead we'll make an &quot;engine&quot; that can run the game from Exercise 47 in the browser.  This will involve refactoring Exercise 43, mixing in the structure from Exercise 47, adding automated tests, and finally creating a web engine that can run the games.</p>
<p>This exercise will be <em>huge</em>, and I predict you could spend anywhere from a week to months on it before moving on.  It's best to attack it in little chunks and do a bit a night, taking your time to make everything work before moving on.</p>
<div class="section" id="refactoring-the-exercise-43-game">
<h1>Refactoring the Exercise 43 Game</h1>
<p>You've been altering the <tt class="docutils literal">gothonweb</tt> project for two exercises and you'll do it one more time in this exercise.  The skill you're learning is called &quot;refactoring,&quot; or as I like to call it, &quot;fixing stuff.&quot;  Refactoring is a term programmers use to describe the process of taking old code, and changing it to have new features or just to clean it up.  You've been doing this without even knowing it, as it's second nature to building software.</p>
<p>What you'll do in this part is take the ideas from Exercise 47 of a testable &quot;map&quot; of Rooms, and the game from Exercise 43, and combine them together to create a new game structure.  It will have the same content, just &quot;refactored&quot; to have a better structure.</p>
<p>The first step is to grab the code from <tt class="docutils literal">ex47/game.py</tt> and copy it to <tt class="docutils literal">gothonweb/map.py</tt> and copy the <tt class="docutils literal">tests/ex47_tests.py</tt> file to <tt class="docutils literal">tests/map_tests.py</tt> and run <tt class="docutils literal">nosetests</tt> again to make sure it keeps working.</p>
<div class="note">
<p class="first admonition-title">Note</p>
<p class="last">From now on I won't show you the output of a test run just assume that you should be doing it and it'll look like the above unless you have an error.</p>
</div>
<p>Once you have the code from Exercise 47 copied over, it's time to refactor it to have the Exercise 43 map in it.  I'm going to start off by laying down the basic structure, and then you'll have an assignment to make the <tt class="docutils literal">map.py</tt> file and the <tt class="docutils literal">map_tests.py</tt> file complete.</p>
<p>Lay out the basic structure of the map using the <tt class="docutils literal">Room</tt> class as it is now:</p>
<table class="highlighttable"><tr><td class="linenos"><div class="linenodiv"><pre>  1
  2
  3
  4
  5
  6
  7
  8
  9
 10
 11
 12
 13
 14
 15
 16
 17
 18
 19
 20
 21
 22
 23
 24
 25
 26
 27
 28
 29
 30
 31
 32
 33
 34
 35
 36
 37
 38
 39
 40
 41
 42
 43
 44
 45
 46
 47
 48
 49
 50
 51
 52
 53
 54
 55
 56
 57
 58
 59
 60
 61
 62
 63
 64
 65
 66
 67
 68
 69
 70
 71
 72
 73
 74
 75
 76
 77
 78
 79
 80
 81
 82
 83
 84
 85
 86
 87
 88
 89
 90
 91
 92
 93
 94
 95
 96
 97
 98
 99
100
101
102
103
104
105
106
107
108
109
110
111
112
113
114
115
116
117
118
119
120
121
122
123
124
125
126
127
128</pre></div></td><td class="code"><div class="highlight"><pre><span></span><a name="python--ex52--gothonweb--gothonweb--map.py-idio.html-1"></a><span class="k">class</span> <span class="nc">Room</span><span class="p">(</span><span class="nb">object</span><span class="p">):</span>
<a name="python--ex52--gothonweb--gothonweb--map.py-idio.html-2"></a>
<a name="python--ex52--gothonweb--gothonweb--map.py-idio.html-3"></a>    <span class="k">def</span> <span class="nf">__init__</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">name</span><span class="p">,</span> <span class="n">description</span><span class="p">):</span>
<a name="python--ex52--gothonweb--gothonweb--map.py-idio.html-4"></a>        <span class="bp">self</span><span class="o">.</span><span class="n">name</span> <span class="o">=</span> <span class="n">name</span>
<a name="python--ex52--gothonweb--gothonweb--map.py-idio.html-5"></a>        <span class="bp">self</span><span class="o">.</span><span class="n">description</span> <span class="o">=</span> <span class="n">description</span>
<a name="python--ex52--gothonweb--gothonweb--map.py-idio.html-6"></a>        <span class="bp">self</span><span class="o">.</span><span class="n">paths</span> <span class="o">=</span> <span class="p">{}</span>
<a name="python--ex52--gothonweb--gothonweb--map.py-idio.html-7"></a>
<a name="python--ex52--gothonweb--gothonweb--map.py-idio.html-8"></a>    <span class="k">def</span> <span class="nf">go</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">direction</span><span class="p">):</span>
<a name="python--ex52--gothonweb--gothonweb--map.py-idio.html-9"></a>        <span class="k">return</span> <span class="bp">self</span><span class="o">.</span><span class="n">paths</span><span class="o">.</span><span class="n">get</span><span class="p">(</span><span class="n">direction</span><span class="p">,</span> <span class="bp">None</span><span class="p">)</span>
<a name="python--ex52--gothonweb--gothonweb--map.py-idio.html-10"></a>
<a name="python--ex52--gothonweb--gothonweb--map.py-idio.html-11"></a>    <span class="k">def</span> <span class="nf">add_paths</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">paths</span><span class="p">):</span>
<a name="python--ex52--gothonweb--gothonweb--map.py-idio.html-12"></a>        <span class="bp">self</span><span class="o">.</span><span class="n">paths</span><span class="o">.</span><span class="n">update</span><span class="p">(</span><span class="n">paths</span><span class="p">)</span>
<a name="python--ex52--gothonweb--gothonweb--map.py-idio.html-13"></a>
<a name="python--ex52--gothonweb--gothonweb--map.py-idio.html-14"></a>
<a name="python--ex52--gothonweb--gothonweb--map.py-idio.html-15"></a><span class="n">central_corridor</span> <span class="o">=</span> <span class="n">Room</span><span class="p">(</span><span class="s2">&quot;Central Corridor&quot;</span><span class="p">,</span>
<a name="python--ex52--gothonweb--gothonweb--map.py-idio.html-16"></a><span class="sd">&quot;&quot;&quot;</span>
<a name="python--ex52--gothonweb--gothonweb--map.py-idio.html-17"></a><span class="sd">The Gothons of Planet Percal #25 have invaded your ship and destroyed</span>
<a name="python--ex52--gothonweb--gothonweb--map.py-idio.html-18"></a><span class="sd">your entire crew.  You are the last surviving member and your last</span>
<a name="python--ex52--gothonweb--gothonweb--map.py-idio.html-19"></a><span class="sd">mission is to get the neutron destruct bomb from the Weapons Armory,</span>
<a name="python--ex52--gothonweb--gothonweb--map.py-idio.html-20"></a><span class="sd">put it in the bridge, and blow the ship up after getting into an </span>
<a name="python--ex52--gothonweb--gothonweb--map.py-idio.html-21"></a><span class="sd">escape pod.</span>
<a name="python--ex52--gothonweb--gothonweb--map.py-idio.html-22"></a>
<a name="python--ex52--gothonweb--gothonweb--map.py-idio.html-23"></a><span class="sd">You&#39;re running down the central corridor to the Weapons Armory when</span>
<a name="python--ex52--gothonweb--gothonweb--map.py-idio.html-24"></a><span class="sd">a Gothon jumps out, red scaly skin, dark grimy teeth, and evil clown costume</span>
<a name="python--ex52--gothonweb--gothonweb--map.py-idio.html-25"></a><span class="sd">flowing around his hate filled body.  He&#39;s blocking the door to the</span>
<a name="python--ex52--gothonweb--gothonweb--map.py-idio.html-26"></a><span class="sd">Armory and about to pull a weapon to blast you.</span>
<a name="python--ex52--gothonweb--gothonweb--map.py-idio.html-27"></a><span class="sd">&quot;&quot;&quot;</span><span class="p">)</span>
<a name="python--ex52--gothonweb--gothonweb--map.py-idio.html-28"></a>
<a name="python--ex52--gothonweb--gothonweb--map.py-idio.html-29"></a>
<a name="python--ex52--gothonweb--gothonweb--map.py-idio.html-30"></a><span class="n">laser_weapon_armory</span> <span class="o">=</span> <span class="n">Room</span><span class="p">(</span><span class="s2">&quot;Laser Weapon Armory&quot;</span><span class="p">,</span>
<a name="python--ex52--gothonweb--gothonweb--map.py-idio.html-31"></a><span class="sd">&quot;&quot;&quot;</span>
<a name="python--ex52--gothonweb--gothonweb--map.py-idio.html-32"></a><span class="sd">Lucky for you they made you learn Gothon insults in the academy.</span>
<a name="python--ex52--gothonweb--gothonweb--map.py-idio.html-33"></a><span class="sd">You tell the one Gothon joke you know:</span>
<a name="python--ex52--gothonweb--gothonweb--map.py-idio.html-34"></a><span class="sd">Lbhe zbgure vf fb sng, jura fur fvgf nebhaq gur ubhfr, fur fvgf nebhaq gur ubhfr.</span>
<a name="python--ex52--gothonweb--gothonweb--map.py-idio.html-35"></a><span class="sd">The Gothon stops, tries not to laugh, then busts out laughing and can&#39;t move.</span>
<a name="python--ex52--gothonweb--gothonweb--map.py-idio.html-36"></a><span class="sd">While he&#39;s laughing you run up and shoot him square in the head</span>
<a name="python--ex52--gothonweb--gothonweb--map.py-idio.html-37"></a><span class="sd">putting him down, then jump through the Weapon Armory door.</span>
<a name="python--ex52--gothonweb--gothonweb--map.py-idio.html-38"></a>
<a name="python--ex52--gothonweb--gothonweb--map.py-idio.html-39"></a><span class="sd">You do a dive roll into the Weapon Armory, crouch and scan the room</span>
<a name="python--ex52--gothonweb--gothonweb--map.py-idio.html-40"></a><span class="sd">for more Gothons that might be hiding.  It&#39;s dead quiet, too quiet.</span>
<a name="python--ex52--gothonweb--gothonweb--map.py-idio.html-41"></a><span class="sd">You stand up and run to the far side of the room and find the</span>
<a name="python--ex52--gothonweb--gothonweb--map.py-idio.html-42"></a><span class="sd">neutron bomb in its container.  There&#39;s a keypad lock on the box</span>
<a name="python--ex52--gothonweb--gothonweb--map.py-idio.html-43"></a><span class="sd">and you need the code to get the bomb out.  If you get the code</span>
<a name="python--ex52--gothonweb--gothonweb--map.py-idio.html-44"></a><span class="sd">wrong 10 times then the lock closes forever and you can&#39;t</span>
<a name="python--ex52--gothonweb--gothonweb--map.py-idio.html-45"></a><span class="sd">get the bomb.  The code is 3 digits.</span>
<a name="python--ex52--gothonweb--gothonweb--map.py-idio.html-46"></a><span class="sd">&quot;&quot;&quot;</span><span class="p">)</span>
<a name="python--ex52--gothonweb--gothonweb--map.py-idio.html-47"></a>
<a name="python--ex52--gothonweb--gothonweb--map.py-idio.html-48"></a>
<a name="python--ex52--gothonweb--gothonweb--map.py-idio.html-49"></a><span class="n">the_bridge</span> <span class="o">=</span> <span class="n">Room</span><span class="p">(</span><span class="s2">&quot;The Bridge&quot;</span><span class="p">,</span>
<a name="python--ex52--gothonweb--gothonweb--map.py-idio.html-50"></a><span class="sd">&quot;&quot;&quot;</span>
<a name="python--ex52--gothonweb--gothonweb--map.py-idio.html-51"></a><span class="sd">The container clicks open and the seal breaks, letting gas out.</span>
<a name="python--ex52--gothonweb--gothonweb--map.py-idio.html-52"></a><span class="sd">You grab the neutron bomb and run as fast as you can to the</span>
<a name="python--ex52--gothonweb--gothonweb--map.py-idio.html-53"></a><span class="sd">bridge where you must place it in the right spot.</span>
<a name="python--ex52--gothonweb--gothonweb--map.py-idio.html-54"></a>
<a name="python--ex52--gothonweb--gothonweb--map.py-idio.html-55"></a><span class="sd">You burst onto the Bridge with the netron destruct bomb</span>
<a name="python--ex52--gothonweb--gothonweb--map.py-idio.html-56"></a><span class="sd">under your arm and surprise 5 Gothons who are trying to</span>
<a name="python--ex52--gothonweb--gothonweb--map.py-idio.html-57"></a><span class="sd">take control of the ship.  Each of them has an even uglier</span>
<a name="python--ex52--gothonweb--gothonweb--map.py-idio.html-58"></a><span class="sd">clown costume than the last.  They haven&#39;t pulled their</span>
<a name="python--ex52--gothonweb--gothonweb--map.py-idio.html-59"></a><span class="sd">weapons out yet, as they see the active bomb under your</span>
<a name="python--ex52--gothonweb--gothonweb--map.py-idio.html-60"></a><span class="sd">arm and don&#39;t want to set it off.</span>
<a name="python--ex52--gothonweb--gothonweb--map.py-idio.html-61"></a><span class="sd">&quot;&quot;&quot;</span><span class="p">)</span>
<a name="python--ex52--gothonweb--gothonweb--map.py-idio.html-62"></a>
<a name="python--ex52--gothonweb--gothonweb--map.py-idio.html-63"></a>
<a name="python--ex52--gothonweb--gothonweb--map.py-idio.html-64"></a><span class="n">escape_pod</span> <span class="o">=</span> <span class="n">Room</span><span class="p">(</span><span class="s2">&quot;Escape Pod&quot;</span><span class="p">,</span>
<a name="python--ex52--gothonweb--gothonweb--map.py-idio.html-65"></a><span class="sd">&quot;&quot;&quot;</span>
<a name="python--ex52--gothonweb--gothonweb--map.py-idio.html-66"></a><span class="sd">You point your blaster at the bomb under your arm</span>
<a name="python--ex52--gothonweb--gothonweb--map.py-idio.html-67"></a><span class="sd">and the Gothons put their hands up and start to sweat.</span>
<a name="python--ex52--gothonweb--gothonweb--map.py-idio.html-68"></a><span class="sd">You inch backward to the door, open it, and then carefully</span>
<a name="python--ex52--gothonweb--gothonweb--map.py-idio.html-69"></a><span class="sd">place the bomb on the floor, pointing your blaster at it.</span>
<a name="python--ex52--gothonweb--gothonweb--map.py-idio.html-70"></a><span class="sd">You then jump back through the door, punch the close button</span>
<a name="python--ex52--gothonweb--gothonweb--map.py-idio.html-71"></a><span class="sd">and blast the lock so the Gothons can&#39;t get out.</span>
<a name="python--ex52--gothonweb--gothonweb--map.py-idio.html-72"></a><span class="sd">Now that the bomb is placed you run to the escape pod to</span>
<a name="python--ex52--gothonweb--gothonweb--map.py-idio.html-73"></a><span class="sd">get off this tin can.</span>
<a name="python--ex52--gothonweb--gothonweb--map.py-idio.html-74"></a>
<a name="python--ex52--gothonweb--gothonweb--map.py-idio.html-75"></a><span class="sd">You rush through the ship desperately trying to make it to</span>
<a name="python--ex52--gothonweb--gothonweb--map.py-idio.html-76"></a><span class="sd">the escape pod before the whole ship explodes.  It seems like</span>
<a name="python--ex52--gothonweb--gothonweb--map.py-idio.html-77"></a><span class="sd">hardly any Gothons are on the ship, so your run is clear of</span>
<a name="python--ex52--gothonweb--gothonweb--map.py-idio.html-78"></a><span class="sd">interference.  You get to the chamber with the escape pods, and</span>
<a name="python--ex52--gothonweb--gothonweb--map.py-idio.html-79"></a><span class="sd">now need to pick one to take.  Some of them could be damaged</span>
<a name="python--ex52--gothonweb--gothonweb--map.py-idio.html-80"></a><span class="sd">but you don&#39;t have time to look.  There&#39;s 5 pods, which one</span>
<a name="python--ex52--gothonweb--gothonweb--map.py-idio.html-81"></a><span class="sd">do you take?</span>
<a name="python--ex52--gothonweb--gothonweb--map.py-idio.html-82"></a><span class="sd">&quot;&quot;&quot;</span><span class="p">)</span>
<a name="python--ex52--gothonweb--gothonweb--map.py-idio.html-83"></a>
<a name="python--ex52--gothonweb--gothonweb--map.py-idio.html-84"></a>
<a name="python--ex52--gothonweb--gothonweb--map.py-idio.html-85"></a><span class="n">the_end_winner</span> <span class="o">=</span> <span class="n">Room</span><span class="p">(</span><span class="s2">&quot;The End&quot;</span><span class="p">,</span>
<a name="python--ex52--gothonweb--gothonweb--map.py-idio.html-86"></a><span class="sd">&quot;&quot;&quot;</span>
<a name="python--ex52--gothonweb--gothonweb--map.py-idio.html-87"></a><span class="sd">You jump into pod 2 and hit the eject button.</span>
<a name="python--ex52--gothonweb--gothonweb--map.py-idio.html-88"></a><span class="sd">The pod easily slides out into space heading to</span>
<a name="python--ex52--gothonweb--gothonweb--map.py-idio.html-89"></a><span class="sd">the planet below.  As it flies to the planet, you look</span>
<a name="python--ex52--gothonweb--gothonweb--map.py-idio.html-90"></a><span class="sd">back and see your ship implode then explode like a</span>
<a name="python--ex52--gothonweb--gothonweb--map.py-idio.html-91"></a><span class="sd">bright star, taking out the Gothon ship at the same</span>
<a name="python--ex52--gothonweb--gothonweb--map.py-idio.html-92"></a><span class="sd">time.  You won!</span>
<a name="python--ex52--gothonweb--gothonweb--map.py-idio.html-93"></a><span class="sd">&quot;&quot;&quot;</span><span class="p">)</span>
<a name="python--ex52--gothonweb--gothonweb--map.py-idio.html-94"></a>
<a name="python--ex52--gothonweb--gothonweb--map.py-idio.html-95"></a>
<a name="python--ex52--gothonweb--gothonweb--map.py-idio.html-96"></a><span class="n">the_end_loser</span> <span class="o">=</span> <span class="n">Room</span><span class="p">(</span><span class="s2">&quot;The End&quot;</span><span class="p">,</span>
<a name="python--ex52--gothonweb--gothonweb--map.py-idio.html-97"></a><span class="sd">&quot;&quot;&quot;</span>
<a name="python--ex52--gothonweb--gothonweb--map.py-idio.html-98"></a><span class="sd">You jump into a random pod and hit the eject button.</span>
<a name="python--ex52--gothonweb--gothonweb--map.py-idio.html-99"></a><span class="sd">The pod escapes out into the void of space, then</span>
<a name="python--ex52--gothonweb--gothonweb--map.py-idio.html-100"></a><span class="sd">implodes as the hull ruptures, crushing your body</span>
<a name="python--ex52--gothonweb--gothonweb--map.py-idio.html-101"></a><span class="sd">into jam jelly.</span>
<a name="python--ex52--gothonweb--gothonweb--map.py-idio.html-102"></a><span class="sd">&quot;&quot;&quot;</span>
<a name="python--ex52--gothonweb--gothonweb--map.py-idio.html-103"></a><span class="p">)</span>
<a name="python--ex52--gothonweb--gothonweb--map.py-idio.html-104"></a>
<a name="python--ex52--gothonweb--gothonweb--map.py-idio.html-105"></a><span class="n">escape_pod</span><span class="o">.</span><span class="n">add_paths</span><span class="p">({</span>
<a name="python--ex52--gothonweb--gothonweb--map.py-idio.html-106"></a>    <span class="s1">&#39;2&#39;</span><span class="p">:</span> <span class="n">the_end_winner</span><span class="p">,</span>
<a name="python--ex52--gothonweb--gothonweb--map.py-idio.html-107"></a>    <span class="s1">&#39;*&#39;</span><span class="p">:</span> <span class="n">the_end_loser</span>
<a name="python--ex52--gothonweb--gothonweb--map.py-idio.html-108"></a><span class="p">})</span>
<a name="python--ex52--gothonweb--gothonweb--map.py-idio.html-109"></a>
<a name="python--ex52--gothonweb--gothonweb--map.py-idio.html-110"></a><span class="n">generic_death</span> <span class="o">=</span> <span class="n">Room</span><span class="p">(</span><span class="s2">&quot;death&quot;</span><span class="p">,</span> <span class="s2">&quot;You died.&quot;</span><span class="p">)</span>
<a name="python--ex52--gothonweb--gothonweb--map.py-idio.html-111"></a>
<a name="python--ex52--gothonweb--gothonweb--map.py-idio.html-112"></a><span class="n">the_bridge</span><span class="o">.</span><span class="n">add_paths</span><span class="p">({</span>
<a name="python--ex52--gothonweb--gothonweb--map.py-idio.html-113"></a>    <span class="s1">&#39;throw the bomb&#39;</span><span class="p">:</span> <span class="n">generic_death</span><span class="p">,</span>
<a name="python--ex52--gothonweb--gothonweb--map.py-idio.html-114"></a>    <span class="s1">&#39;slowly place the bomb&#39;</span><span class="p">:</span> <span class="n">escape_pod</span>
<a name="python--ex52--gothonweb--gothonweb--map.py-idio.html-115"></a><span class="p">})</span>
<a name="python--ex52--gothonweb--gothonweb--map.py-idio.html-116"></a>
<a name="python--ex52--gothonweb--gothonweb--map.py-idio.html-117"></a><span class="n">laser_weapon_armory</span><span class="o">.</span><span class="n">add_paths</span><span class="p">({</span>
<a name="python--ex52--gothonweb--gothonweb--map.py-idio.html-118"></a>    <span class="s1">&#39;0132&#39;</span><span class="p">:</span> <span class="n">the_bridge</span><span class="p">,</span>
<a name="python--ex52--gothonweb--gothonweb--map.py-idio.html-119"></a>    <span class="s1">&#39;*&#39;</span><span class="p">:</span> <span class="n">generic_death</span>
<a name="python--ex52--gothonweb--gothonweb--map.py-idio.html-120"></a><span class="p">})</span>
<a name="python--ex52--gothonweb--gothonweb--map.py-idio.html-121"></a>
<a name="python--ex52--gothonweb--gothonweb--map.py-idio.html-122"></a><span class="n">central_corridor</span><span class="o">.</span><span class="n">add_paths</span><span class="p">({</span>
<a name="python--ex52--gothonweb--gothonweb--map.py-idio.html-123"></a>    <span class="s1">&#39;shoot!&#39;</span><span class="p">:</span> <span class="n">generic_death</span><span class="p">,</span>
<a name="python--ex52--gothonweb--gothonweb--map.py-idio.html-124"></a>    <span class="s1">&#39;dodge!&#39;</span><span class="p">:</span> <span class="n">generic_death</span><span class="p">,</span>
<a name="python--ex52--gothonweb--gothonweb--map.py-idio.html-125"></a>    <span class="s1">&#39;tell a joke&#39;</span><span class="p">:</span> <span class="n">laser_weapon_armory</span>
<a name="python--ex52--gothonweb--gothonweb--map.py-idio.html-126"></a><span class="p">})</span>
<a name="python--ex52--gothonweb--gothonweb--map.py-idio.html-127"></a>
<a name="python--ex52--gothonweb--gothonweb--map.py-idio.html-128"></a><span class="n">START</span> <span class="o">=</span> <span class="n">central_corridor</span>
</pre></div>
</td></tr></table><p>You'll notice that there are a couple of problems with our <tt class="docutils literal">Room</tt> class and this map:</p>
<ol class="arabic simple">
<li>We have to put the text that was in the <tt class="docutils literal"><span class="pre">if-else</span></tt> clauses that got printed <em>before</em> entering a room as part of each room.  This means you can't shuffle the map around, which would be nice.  You'll be fixing that up in this exercise.</li>
<li>There are parts in the original game where we ran code that determined things like the bomb's keypad code, or the right pod.  In this game we just pick some defaults and go with it, but later you'll be given Study Drills to make this work again.</li>
<li>I've just made a <tt class="docutils literal">generic_death</tt> ending for all of the bad decisions, which you'll have to finish for me.  You'll need to go back through and add in all the original endings and make sure they work.</li>
<li>I've got a new kind of transition labeled <tt class="docutils literal">&quot;*&quot;</tt> that will be used for a &quot;catch-all&quot; action in the engine.</li>
</ol>
<p>Once you've got that basically written out, here's the new automated test <tt class="docutils literal">tests/map_test.py</tt> that you should have to get yourself started:</p>
<table class="highlighttable"><tr><td class="linenos"><div class="linenodiv"><pre> 1
 2
 3
 4
 5
 6
 7
 8
 9
10
11
12
13
14
15
16
17
18
19
20
21
22
23
24
25
26
27
28
29
30
31
32
33
34
35
36
37
38</pre></div></td><td class="code"><div class="highlight"><pre><span></span><a name="python--ex52--gothonweb--tests--map_tests.py-idio.html-1"></a><span class="kn">from</span> <span class="nn">nose.tools</span> <span class="kn">import</span> <span class="o">*</span>
<a name="python--ex52--gothonweb--tests--map_tests.py-idio.html-2"></a><span class="kn">from</span> <span class="nn">gothonweb.map</span> <span class="kn">import</span> <span class="o">*</span>
<a name="python--ex52--gothonweb--tests--map_tests.py-idio.html-3"></a>
<a name="python--ex52--gothonweb--tests--map_tests.py-idio.html-4"></a><span class="k">def</span> <span class="nf">test_room</span><span class="p">():</span>
<a name="python--ex52--gothonweb--tests--map_tests.py-idio.html-5"></a>    <span class="n">gold</span> <span class="o">=</span> <span class="n">Room</span><span class="p">(</span><span class="s2">&quot;GoldRoom&quot;</span><span class="p">,</span>
<a name="python--ex52--gothonweb--tests--map_tests.py-idio.html-6"></a>                <span class="sd">&quot;&quot;&quot;This room has gold in it you can grab. There&#39;s a</span>
<a name="python--ex52--gothonweb--tests--map_tests.py-idio.html-7"></a><span class="sd">                door to the north.&quot;&quot;&quot;</span><span class="p">)</span>
<a name="python--ex52--gothonweb--tests--map_tests.py-idio.html-8"></a>    <span class="n">assert_equal</span><span class="p">(</span><span class="n">gold</span><span class="o">.</span><span class="n">name</span><span class="p">,</span> <span class="s2">&quot;GoldRoom&quot;</span><span class="p">)</span>
<a name="python--ex52--gothonweb--tests--map_tests.py-idio.html-9"></a>    <span class="n">assert_equal</span><span class="p">(</span><span class="n">gold</span><span class="o">.</span><span class="n">paths</span><span class="p">,</span> <span class="p">{})</span>
<a name="python--ex52--gothonweb--tests--map_tests.py-idio.html-10"></a>
<a name="python--ex52--gothonweb--tests--map_tests.py-idio.html-11"></a><span class="k">def</span> <span class="nf">test_room_paths</span><span class="p">():</span>
<a name="python--ex52--gothonweb--tests--map_tests.py-idio.html-12"></a>    <span class="n">center</span> <span class="o">=</span> <span class="n">Room</span><span class="p">(</span><span class="s2">&quot;Center&quot;</span><span class="p">,</span> <span class="s2">&quot;Test room in the center.&quot;</span><span class="p">)</span>
<a name="python--ex52--gothonweb--tests--map_tests.py-idio.html-13"></a>    <span class="n">north</span> <span class="o">=</span> <span class="n">Room</span><span class="p">(</span><span class="s2">&quot;North&quot;</span><span class="p">,</span> <span class="s2">&quot;Test room in the north.&quot;</span><span class="p">)</span>
<a name="python--ex52--gothonweb--tests--map_tests.py-idio.html-14"></a>    <span class="n">south</span> <span class="o">=</span> <span class="n">Room</span><span class="p">(</span><span class="s2">&quot;South&quot;</span><span class="p">,</span> <span class="s2">&quot;Test room in the south.&quot;</span><span class="p">)</span>
<a name="python--ex52--gothonweb--tests--map_tests.py-idio.html-15"></a>
<a name="python--ex52--gothonweb--tests--map_tests.py-idio.html-16"></a>    <span class="n">center</span><span class="o">.</span><span class="n">add_paths</span><span class="p">({</span><span class="s1">&#39;north&#39;</span><span class="p">:</span> <span class="n">north</span><span class="p">,</span> <span class="s1">&#39;south&#39;</span><span class="p">:</span> <span class="n">south</span><span class="p">})</span>
<a name="python--ex52--gothonweb--tests--map_tests.py-idio.html-17"></a>    <span class="n">assert_equal</span><span class="p">(</span><span class="n">center</span><span class="o">.</span><span class="n">go</span><span class="p">(</span><span class="s1">&#39;north&#39;</span><span class="p">),</span> <span class="n">north</span><span class="p">)</span>
<a name="python--ex52--gothonweb--tests--map_tests.py-idio.html-18"></a>    <span class="n">assert_equal</span><span class="p">(</span><span class="n">center</span><span class="o">.</span><span class="n">go</span><span class="p">(</span><span class="s1">&#39;south&#39;</span><span class="p">),</span> <span class="n">south</span><span class="p">)</span>
<a name="python--ex52--gothonweb--tests--map_tests.py-idio.html-19"></a>
<a name="python--ex52--gothonweb--tests--map_tests.py-idio.html-20"></a><span class="k">def</span> <span class="nf">test_map</span><span class="p">():</span>
<a name="python--ex52--gothonweb--tests--map_tests.py-idio.html-21"></a>    <span class="n">start</span> <span class="o">=</span> <span class="n">Room</span><span class="p">(</span><span class="s2">&quot;Start&quot;</span><span class="p">,</span> <span class="s2">&quot;You can go west and down a hole.&quot;</span><span class="p">)</span>
<a name="python--ex52--gothonweb--tests--map_tests.py-idio.html-22"></a>    <span class="n">west</span> <span class="o">=</span> <span class="n">Room</span><span class="p">(</span><span class="s2">&quot;Trees&quot;</span><span class="p">,</span> <span class="s2">&quot;There are trees here, you can go east.&quot;</span><span class="p">)</span>
<a name="python--ex52--gothonweb--tests--map_tests.py-idio.html-23"></a>    <span class="n">down</span> <span class="o">=</span> <span class="n">Room</span><span class="p">(</span><span class="s2">&quot;Dungeon&quot;</span><span class="p">,</span> <span class="s2">&quot;It&#39;s dark down here, you can go up.&quot;</span><span class="p">)</span>
<a name="python--ex52--gothonweb--tests--map_tests.py-idio.html-24"></a>
<a name="python--ex52--gothonweb--tests--map_tests.py-idio.html-25"></a>    <span class="n">start</span><span class="o">.</span><span class="n">add_paths</span><span class="p">({</span><span class="s1">&#39;west&#39;</span><span class="p">:</span> <span class="n">west</span><span class="p">,</span> <span class="s1">&#39;down&#39;</span><span class="p">:</span> <span class="n">down</span><span class="p">})</span>
<a name="python--ex52--gothonweb--tests--map_tests.py-idio.html-26"></a>    <span class="n">west</span><span class="o">.</span><span class="n">add_paths</span><span class="p">({</span><span class="s1">&#39;east&#39;</span><span class="p">:</span> <span class="n">start</span><span class="p">})</span>
<a name="python--ex52--gothonweb--tests--map_tests.py-idio.html-27"></a>    <span class="n">down</span><span class="o">.</span><span class="n">add_paths</span><span class="p">({</span><span class="s1">&#39;up&#39;</span><span class="p">:</span> <span class="n">start</span><span class="p">})</span>
<a name="python--ex52--gothonweb--tests--map_tests.py-idio.html-28"></a>
<a name="python--ex52--gothonweb--tests--map_tests.py-idio.html-29"></a>    <span class="n">assert_equal</span><span class="p">(</span><span class="n">start</span><span class="o">.</span><span class="n">go</span><span class="p">(</span><span class="s1">&#39;west&#39;</span><span class="p">),</span> <span class="n">west</span><span class="p">)</span>
<a name="python--ex52--gothonweb--tests--map_tests.py-idio.html-30"></a>    <span class="n">assert_equal</span><span class="p">(</span><span class="n">start</span><span class="o">.</span><span class="n">go</span><span class="p">(</span><span class="s1">&#39;west&#39;</span><span class="p">)</span><span class="o">.</span><span class="n">go</span><span class="p">(</span><span class="s1">&#39;east&#39;</span><span class="p">),</span> <span class="n">start</span><span class="p">)</span>
<a name="python--ex52--gothonweb--tests--map_tests.py-idio.html-31"></a>    <span class="n">assert_equal</span><span class="p">(</span><span class="n">start</span><span class="o">.</span><span class="n">go</span><span class="p">(</span><span class="s1">&#39;down&#39;</span><span class="p">)</span><span class="o">.</span><span class="n">go</span><span class="p">(</span><span class="s1">&#39;up&#39;</span><span class="p">),</span> <span class="n">start</span><span class="p">)</span>
<a name="python--ex52--gothonweb--tests--map_tests.py-idio.html-32"></a>
<a name="python--ex52--gothonweb--tests--map_tests.py-idio.html-33"></a><span class="k">def</span> <span class="nf">test_gothon_game_map</span><span class="p">():</span>
<a name="python--ex52--gothonweb--tests--map_tests.py-idio.html-34"></a>    <span class="n">assert_equal</span><span class="p">(</span><span class="n">START</span><span class="o">.</span><span class="n">go</span><span class="p">(</span><span class="s1">&#39;shoot!&#39;</span><span class="p">),</span> <span class="n">generic_death</span><span class="p">)</span>
<a name="python--ex52--gothonweb--tests--map_tests.py-idio.html-35"></a>    <span class="n">assert_equal</span><span class="p">(</span><span class="n">START</span><span class="o">.</span><span class="n">go</span><span class="p">(</span><span class="s1">&#39;dodge!&#39;</span><span class="p">),</span> <span class="n">generic_death</span><span class="p">)</span>
<a name="python--ex52--gothonweb--tests--map_tests.py-idio.html-36"></a>
<a name="python--ex52--gothonweb--tests--map_tests.py-idio.html-37"></a>    <span class="n">room</span> <span class="o">=</span> <span class="n">START</span><span class="o">.</span><span class="n">go</span><span class="p">(</span><span class="s1">&#39;tell a joke&#39;</span><span class="p">)</span>
<a name="python--ex52--gothonweb--tests--map_tests.py-idio.html-38"></a>    <span class="n">assert_equal</span><span class="p">(</span><span class="n">room</span><span class="p">,</span> <span class="n">laser_weapon_armory</span><span class="p">)</span>
</pre></div>
</td></tr></table><p>Your task in this part of the exercise is to complete the map, and make the automated test completely validate the whole map.  This includes fixing all the <tt class="docutils literal">generic_death</tt> objects to be real endings.  Make sure this works really well and that your test is as complete as possible because we'll be changing this map later and you'll use the tests to make sure it keeps working.</p>
</div>
<div class="section" id="sessions-and-tracking-users">
<h1>Sessions and Tracking Users</h1>
<p>At a certain point in your web application you'll need to keep track of some information and associate it with the user's browser.  The web (because of HTTP) is what we like to call &quot;stateless,&quot; which means each request you make is independent of any other requests being made.  If you request page A, put in some data, and click a link to page B, all the data you sent to page A just disappears.</p>
<p>The solution to this is to create a little data store (usually in a database or on the disk) that uses a number unique to each browser to keep track of what that browser was doing. This is called &quot;session tracking&quot; and uses Cookies in the browser to maintain the state of the user through the application.  In the little <tt class="docutils literal">lpthw.web</tt> framework it's fairly easy, and there's an example showing how it's done:</p>
<table class="highlighttable"><tr><td class="linenos"><div class="linenodiv"><pre> 1
 2
 3
 4
 5
 6
 7
 8
 9
10
11
12
13
14
15
16
17
18
19
20
21
22
23
24</pre></div></td><td class="code"><div class="highlight"><pre><span></span><a name="python--ex52--gothonweb--session_sample.py-idio.html-1"></a><span class="kn">import</span> <span class="nn">web</span>
<a name="python--ex52--gothonweb--session_sample.py-idio.html-2"></a>
<a name="python--ex52--gothonweb--session_sample.py-idio.html-3"></a><span class="n">web</span><span class="o">.</span><span class="n">config</span><span class="o">.</span><span class="n">debug</span> <span class="o">=</span> <span class="bp">False</span>
<a name="python--ex52--gothonweb--session_sample.py-idio.html-4"></a>
<a name="python--ex52--gothonweb--session_sample.py-idio.html-5"></a><span class="n">urls</span> <span class="o">=</span> <span class="p">(</span>
<a name="python--ex52--gothonweb--session_sample.py-idio.html-6"></a>    <span class="s2">&quot;/count&quot;</span><span class="p">,</span> <span class="s2">&quot;count&quot;</span><span class="p">,</span>
<a name="python--ex52--gothonweb--session_sample.py-idio.html-7"></a>    <span class="s2">&quot;/reset&quot;</span><span class="p">,</span> <span class="s2">&quot;reset&quot;</span>
<a name="python--ex52--gothonweb--session_sample.py-idio.html-8"></a><span class="p">)</span>
<a name="python--ex52--gothonweb--session_sample.py-idio.html-9"></a><span class="n">app</span> <span class="o">=</span> <span class="n">web</span><span class="o">.</span><span class="n">application</span><span class="p">(</span><span class="n">urls</span><span class="p">,</span> <span class="nb">locals</span><span class="p">())</span>
<a name="python--ex52--gothonweb--session_sample.py-idio.html-10"></a><span class="n">store</span> <span class="o">=</span> <span class="n">web</span><span class="o">.</span><span class="n">session</span><span class="o">.</span><span class="n">DiskStore</span><span class="p">(</span><span class="s1">&#39;sessions&#39;</span><span class="p">)</span>
<a name="python--ex52--gothonweb--session_sample.py-idio.html-11"></a><span class="n">session</span> <span class="o">=</span> <span class="n">web</span><span class="o">.</span><span class="n">session</span><span class="o">.</span><span class="n">Session</span><span class="p">(</span><span class="n">app</span><span class="p">,</span> <span class="n">store</span><span class="p">,</span> <span class="n">initializer</span><span class="o">=</span><span class="p">{</span><span class="s1">&#39;count&#39;</span><span class="p">:</span> <span class="mi">0</span><span class="p">})</span>
<a name="python--ex52--gothonweb--session_sample.py-idio.html-12"></a>
<a name="python--ex52--gothonweb--session_sample.py-idio.html-13"></a><span class="k">class</span> <span class="nc">count</span><span class="p">:</span>
<a name="python--ex52--gothonweb--session_sample.py-idio.html-14"></a>    <span class="k">def</span> <span class="nf">GET</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
<a name="python--ex52--gothonweb--session_sample.py-idio.html-15"></a>        <span class="n">session</span><span class="o">.</span><span class="n">count</span> <span class="o">+=</span> <span class="mi">1</span>
<a name="python--ex52--gothonweb--session_sample.py-idio.html-16"></a>        <span class="k">return</span> <span class="nb">str</span><span class="p">(</span><span class="n">session</span><span class="o">.</span><span class="n">count</span><span class="p">)</span>
<a name="python--ex52--gothonweb--session_sample.py-idio.html-17"></a>
<a name="python--ex52--gothonweb--session_sample.py-idio.html-18"></a><span class="k">class</span> <span class="nc">reset</span><span class="p">:</span>
<a name="python--ex52--gothonweb--session_sample.py-idio.html-19"></a>    <span class="k">def</span> <span class="nf">GET</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
<a name="python--ex52--gothonweb--session_sample.py-idio.html-20"></a>        <span class="n">session</span><span class="o">.</span><span class="n">kill</span><span class="p">()</span>
<a name="python--ex52--gothonweb--session_sample.py-idio.html-21"></a>        <span class="k">return</span> <span class="s2">&quot;&quot;</span>
<a name="python--ex52--gothonweb--session_sample.py-idio.html-22"></a>
<a name="python--ex52--gothonweb--session_sample.py-idio.html-23"></a><span class="k">if</span> <span class="n">__name__</span> <span class="o">==</span> <span class="s2">&quot;__main__&quot;</span><span class="p">:</span>
<a name="python--ex52--gothonweb--session_sample.py-idio.html-24"></a>    <span class="n">app</span><span class="o">.</span><span class="n">run</span><span class="p">()</span>
</pre></div>
</td></tr></table><p>To make this work, you need to create a <tt class="docutils literal">sessions/</tt> directory where the application can put session storage.  Do that,  run this application, and go to <tt class="docutils literal">/count</tt>. Hit refresh and watch the counter go up.  Close the browser and it <em>forgets</em> who you are, which is what we want for the game.  There's a way to make the browser remember forever, but that makes testing and development harder.  If you then go to <tt class="docutils literal">/reset</tt> and back to <tt class="docutils literal">/count</tt> you can see your counter reset because you've killed the session.</p>
<p>Take the time to understand this code so you can see how the session starts off with the <tt class="docutils literal">count</tt> equal to 0.  Also try looking at the files in <tt class="docutils literal">sessions/</tt> to see if you can open them up.  Here's a Python session where I open up one and decode it:</p>
<pre class="code pycon literal-block">
<span class="keyword namespace"></span><span class="generic prompt">&gt;&gt;&gt; </span><span class="keyword namespace">import</span> <span class="name namespace">pickle</span>
<span class="generic prompt">&gt;&gt;&gt; </span><span class="keyword namespace">import</span> <span class="name namespace">base64</span>
<span class="generic prompt">&gt;&gt;&gt; </span><span class="name">base64</span><span class="operator">.</span><span class="name">b64decode</span><span class="punctuation">(</span><span class="name builtin">open</span><span class="punctuation">(</span><span class="literal string double">&quot;sessions/XXXXX&quot;</span><span class="punctuation">)</span><span class="operator">.</span><span class="name">read</span><span class="punctuation">())</span>
<span class="generic output">&quot;(dp1\nS'count'\np2\nI1\nsS'ip'\np3\nV127.0.0.1\np4\nsS'session_id'\np5\nS'XXXX'\np6\ns.&quot;
&gt;&gt;&gt;
</span><span class="name"></span><span class="generic prompt">&gt;&gt;&gt; </span><span class="name">x</span> <span class="operator">=</span> <span class="name">base64</span><span class="operator">.</span><span class="name">b64decode</span><span class="punctuation">(</span><span class="name builtin">open</span><span class="punctuation">(</span><span class="literal string double">&quot;sessions/XXXXX&quot;</span><span class="punctuation">)</span><span class="operator">.</span><span class="name">read</span><span class="punctuation">())</span>
<span class="generic output">&gt;&gt;&gt;
</span><span class="name"></span><span class="generic prompt">&gt;&gt;&gt; </span><span class="name">pickle</span><span class="operator">.</span><span class="name">loads</span><span class="punctuation">(</span><span class="name">x</span><span class="punctuation">)</span>
<span class="generic output">{'count': 1, 'ip': u'127.0.0.1', 'session_id': 'XXXXX'}</span>
</pre>
<p>The sessions are really just dictionaries that get written to disk using <tt class="docutils literal">pickle</tt> and <tt class="docutils literal">base64</tt> libraries.  There are probably as many ways to store and manage sessions as there are web frameworks, so it's not too important to know how these work.  It does help if you need to debug the session or potentially clean it out.</p>
</div>
<div class="section" id="creating-an-engine">
<h1>Creating an Engine</h1>
<p>You should have your game map working and a good unit test for it.  I now want you to make a simple little game engine that will run the rooms, collect input from the player, and keep track of where a player is in the game.  We'll be using the sessions you just learned to make a simple game engine that will:</p>
<ol class="arabic simple">
<li>Start a new game for new users.</li>
<li>Present the room to the user.</li>
<li>Take input from the user.</li>
<li>Run user input through the game.</li>
<li>Display the results and keep going until the user dies.</li>
</ol>
<p>To do this, you're going to take the trusty <tt class="docutils literal">bin/app.py</tt> you've been hacking on and create a fully working, session-based game engine.  The catch is I'm going to make a very simple one with <em>basic HTML</em> files, and it'll be up to you to complete it.   Here's the base engine:</p>
<table class="highlighttable"><tr><td class="linenos"><div class="linenodiv"><pre> 1
 2
 3
 4
 5
 6
 7
 8
 9
10
11
12
13
14
15
16
17
18
19
20
21
22
23
24
25
26
27
28
29
30
31
32
33
34
35
36
37
38
39
40
41
42
43
44
45
46
47
48
49</pre></div></td><td class="code"><div class="highlight"><pre><span></span><a name="python--ex52--gothonweb--bin--app.py-idio.html-1"></a><span class="kn">import</span> <span class="nn">web</span>
<a name="python--ex52--gothonweb--bin--app.py-idio.html-2"></a><span class="kn">from</span> <span class="nn">gothonweb</span> <span class="kn">import</span> <span class="nb">map</span>
<a name="python--ex52--gothonweb--bin--app.py-idio.html-3"></a>
<a name="python--ex52--gothonweb--bin--app.py-idio.html-4"></a><span class="n">urls</span> <span class="o">=</span> <span class="p">(</span>
<a name="python--ex52--gothonweb--bin--app.py-idio.html-5"></a>  <span class="s1">&#39;/game&#39;</span><span class="p">,</span> <span class="s1">&#39;GameEngine&#39;</span><span class="p">,</span>
<a name="python--ex52--gothonweb--bin--app.py-idio.html-6"></a>  <span class="s1">&#39;/&#39;</span><span class="p">,</span> <span class="s1">&#39;Index&#39;</span><span class="p">,</span>
<a name="python--ex52--gothonweb--bin--app.py-idio.html-7"></a><span class="p">)</span>
<a name="python--ex52--gothonweb--bin--app.py-idio.html-8"></a>
<a name="python--ex52--gothonweb--bin--app.py-idio.html-9"></a><span class="n">app</span> <span class="o">=</span> <span class="n">web</span><span class="o">.</span><span class="n">application</span><span class="p">(</span><span class="n">urls</span><span class="p">,</span> <span class="nb">globals</span><span class="p">())</span>
<a name="python--ex52--gothonweb--bin--app.py-idio.html-10"></a>
<a name="python--ex52--gothonweb--bin--app.py-idio.html-11"></a><span class="c1"># little hack so that debug mode works with sessions</span>
<a name="python--ex52--gothonweb--bin--app.py-idio.html-12"></a><span class="k">if</span> <span class="n">web</span><span class="o">.</span><span class="n">config</span><span class="o">.</span><span class="n">get</span><span class="p">(</span><span class="s1">&#39;_session&#39;</span><span class="p">)</span> <span class="ow">is</span> <span class="bp">None</span><span class="p">:</span>
<a name="python--ex52--gothonweb--bin--app.py-idio.html-13"></a>    <span class="n">store</span> <span class="o">=</span> <span class="n">web</span><span class="o">.</span><span class="n">session</span><span class="o">.</span><span class="n">DiskStore</span><span class="p">(</span><span class="s1">&#39;sessions&#39;</span><span class="p">)</span>
<a name="python--ex52--gothonweb--bin--app.py-idio.html-14"></a>    <span class="n">session</span> <span class="o">=</span> <span class="n">web</span><span class="o">.</span><span class="n">session</span><span class="o">.</span><span class="n">Session</span><span class="p">(</span><span class="n">app</span><span class="p">,</span> <span class="n">store</span><span class="p">,</span>
<a name="python--ex52--gothonweb--bin--app.py-idio.html-15"></a>                                  <span class="n">initializer</span><span class="o">=</span><span class="p">{</span><span class="s1">&#39;room&#39;</span><span class="p">:</span> <span class="bp">None</span><span class="p">})</span>
<a name="python--ex52--gothonweb--bin--app.py-idio.html-16"></a>    <span class="n">web</span><span class="o">.</span><span class="n">config</span><span class="o">.</span><span class="n">_session</span> <span class="o">=</span> <span class="n">session</span>
<a name="python--ex52--gothonweb--bin--app.py-idio.html-17"></a><span class="k">else</span><span class="p">:</span>
<a name="python--ex52--gothonweb--bin--app.py-idio.html-18"></a>    <span class="n">session</span> <span class="o">=</span> <span class="n">web</span><span class="o">.</span><span class="n">config</span><span class="o">.</span><span class="n">_session</span>
<a name="python--ex52--gothonweb--bin--app.py-idio.html-19"></a>
<a name="python--ex52--gothonweb--bin--app.py-idio.html-20"></a><span class="n">render</span> <span class="o">=</span> <span class="n">web</span><span class="o">.</span><span class="n">template</span><span class="o">.</span><span class="n">render</span><span class="p">(</span><span class="s1">&#39;templates/&#39;</span><span class="p">,</span> <span class="n">base</span><span class="o">=</span><span class="s2">&quot;layout&quot;</span><span class="p">)</span>
<a name="python--ex52--gothonweb--bin--app.py-idio.html-21"></a>
<a name="python--ex52--gothonweb--bin--app.py-idio.html-22"></a>
<a name="python--ex52--gothonweb--bin--app.py-idio.html-23"></a><span class="k">class</span> <span class="nc">Index</span><span class="p">(</span><span class="nb">object</span><span class="p">):</span>
<a name="python--ex52--gothonweb--bin--app.py-idio.html-24"></a>    <span class="k">def</span> <span class="nf">GET</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
<a name="python--ex52--gothonweb--bin--app.py-idio.html-25"></a>        <span class="c1"># this is used to &quot;setup&quot; the session with starting values</span>
<a name="python--ex52--gothonweb--bin--app.py-idio.html-26"></a>        <span class="n">session</span><span class="o">.</span><span class="n">room</span> <span class="o">=</span> <span class="nb">map</span><span class="o">.</span><span class="n">START</span>
<a name="python--ex52--gothonweb--bin--app.py-idio.html-27"></a>        <span class="n">web</span><span class="o">.</span><span class="n">seeother</span><span class="p">(</span><span class="s2">&quot;/game&quot;</span><span class="p">)</span>
<a name="python--ex52--gothonweb--bin--app.py-idio.html-28"></a>
<a name="python--ex52--gothonweb--bin--app.py-idio.html-29"></a>
<a name="python--ex52--gothonweb--bin--app.py-idio.html-30"></a><span class="k">class</span> <span class="nc">GameEngine</span><span class="p">(</span><span class="nb">object</span><span class="p">):</span>
<a name="python--ex52--gothonweb--bin--app.py-idio.html-31"></a>
<a name="python--ex52--gothonweb--bin--app.py-idio.html-32"></a>    <span class="k">def</span> <span class="nf">GET</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
<a name="python--ex52--gothonweb--bin--app.py-idio.html-33"></a>        <span class="k">if</span> <span class="n">session</span><span class="o">.</span><span class="n">room</span><span class="p">:</span>
<a name="python--ex52--gothonweb--bin--app.py-idio.html-34"></a>            <span class="k">return</span> <span class="n">render</span><span class="o">.</span><span class="n">show_room</span><span class="p">(</span><span class="n">room</span><span class="o">=</span><span class="n">session</span><span class="o">.</span><span class="n">room</span><span class="p">)</span>
<a name="python--ex52--gothonweb--bin--app.py-idio.html-35"></a>        <span class="k">else</span><span class="p">:</span>
<a name="python--ex52--gothonweb--bin--app.py-idio.html-36"></a>            <span class="c1"># why is there here? do you need it?</span>
<a name="python--ex52--gothonweb--bin--app.py-idio.html-37"></a>            <span class="k">return</span> <span class="n">render</span><span class="o">.</span><span class="n">you_died</span><span class="p">()</span>
<a name="python--ex52--gothonweb--bin--app.py-idio.html-38"></a>
<a name="python--ex52--gothonweb--bin--app.py-idio.html-39"></a>    <span class="k">def</span> <span class="nf">POST</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
<a name="python--ex52--gothonweb--bin--app.py-idio.html-40"></a>        <span class="n">form</span> <span class="o">=</span> <span class="n">web</span><span class="o">.</span><span class="n">input</span><span class="p">(</span><span class="n">action</span><span class="o">=</span><span class="bp">None</span><span class="p">)</span>
<a name="python--ex52--gothonweb--bin--app.py-idio.html-41"></a>
<a name="python--ex52--gothonweb--bin--app.py-idio.html-42"></a>        <span class="c1"># there is a bug here, can you fix it?</span>
<a name="python--ex52--gothonweb--bin--app.py-idio.html-43"></a>        <span class="k">if</span> <span class="n">session</span><span class="o">.</span><span class="n">room</span> <span class="ow">and</span> <span class="n">form</span><span class="o">.</span><span class="n">action</span><span class="p">:</span>
<a name="python--ex52--gothonweb--bin--app.py-idio.html-44"></a>            <span class="n">session</span><span class="o">.</span><span class="n">room</span> <span class="o">=</span> <span class="n">session</span><span class="o">.</span><span class="n">room</span><span class="o">.</span><span class="n">go</span><span class="p">(</span><span class="n">form</span><span class="o">.</span><span class="n">action</span><span class="p">)</span>
<a name="python--ex52--gothonweb--bin--app.py-idio.html-45"></a>
<a name="python--ex52--gothonweb--bin--app.py-idio.html-46"></a>        <span class="n">web</span><span class="o">.</span><span class="n">seeother</span><span class="p">(</span><span class="s2">&quot;/game&quot;</span><span class="p">)</span>
<a name="python--ex52--gothonweb--bin--app.py-idio.html-47"></a>
<a name="python--ex52--gothonweb--bin--app.py-idio.html-48"></a><span class="k">if</span> <span class="n">__name__</span> <span class="o">==</span> <span class="s2">&quot;__main__&quot;</span><span class="p">:</span>
<a name="python--ex52--gothonweb--bin--app.py-idio.html-49"></a>    <span class="n">app</span><span class="o">.</span><span class="n">run</span><span class="p">()</span>
</pre></div>
</td></tr></table><p>There are even more new things in this script, but amazingly it's an entire web-based game engine in a small file.  The biggest &quot;hack&quot; in the script are the lines that bring the sessions back, which is needed so that debug mode reloading works.  Otherwise, each time you hit refresh the sessions will disappear and the game won't work.</p>
<p>Before you run bin/app.py you need to change your PYTHONPATH environment variable.  Don't know what that is?  I know, it's kind of dumb, but you have to learn what this is to run even basic Python programs, but that's how Python people like things.</p>
<p>In your Terminal, type:</p>
<pre class="code console literal-block">
<span class="generic output">export PYTHONPATH=$PYTHONPATH:.</span>
</pre>
<p>On Windows PowerShell do:</p>
<pre class="code console literal-block">
<span class="generic prompt">$</span>env:PYTHONPATH <span class="operator">=</span> <span class="literal string double">&quot;</span><span class="name variable">$env</span><span class="literal string double">:PYTHONPATH;.&quot;</span>
</pre>
<p>You should only have to do it once per shell session, but if you get an import error, then you probably need to do this or you did it wrong.</p>
<p>You should next delete <tt class="docutils literal">templates/hello_form.html</tt> and <tt class="docutils literal">templates/index.html</tt> and create the two templates mentioned in the above code.  Here's a <em>very</em> simple <tt class="docutils literal">templates/show_room.html</tt>:</p>
<div class="highlight"><pre><span></span><a name="python--ex52--gothonweb--templates--show_room.html-pyg.html-1"></a>$def with (room)
<a name="python--ex52--gothonweb--templates--show_room.html-pyg.html-2"></a>
<a name="python--ex52--gothonweb--templates--show_room.html-pyg.html-3"></a><span class="p">&lt;</span><span class="nt">h1</span><span class="p">&gt;</span> $room.name <span class="p">&lt;/</span><span class="nt">h1</span><span class="p">&gt;</span>
<a name="python--ex52--gothonweb--templates--show_room.html-pyg.html-4"></a>
<a name="python--ex52--gothonweb--templates--show_room.html-pyg.html-5"></a><span class="p">&lt;</span><span class="nt">pre</span><span class="p">&gt;</span>
<a name="python--ex52--gothonweb--templates--show_room.html-pyg.html-6"></a>$room.description
<a name="python--ex52--gothonweb--templates--show_room.html-pyg.html-7"></a><span class="p">&lt;/</span><span class="nt">pre</span><span class="p">&gt;</span>
<a name="python--ex52--gothonweb--templates--show_room.html-pyg.html-8"></a>
<a name="python--ex52--gothonweb--templates--show_room.html-pyg.html-9"></a>$if room.name == &quot;death&quot;:
<a name="python--ex52--gothonweb--templates--show_room.html-pyg.html-10"></a>    <span class="p">&lt;</span><span class="nt">p</span><span class="p">&gt;&lt;</span><span class="nt">a</span> <span class="na">href</span><span class="o">=</span><span class="s">&quot;/&quot;</span><span class="p">&gt;</span>Play Again?<span class="p">&lt;/</span><span class="nt">a</span><span class="p">&gt;&lt;/</span><span class="nt">p</span><span class="p">&gt;</span>
<a name="python--ex52--gothonweb--templates--show_room.html-pyg.html-11"></a>$else:
<a name="python--ex52--gothonweb--templates--show_room.html-pyg.html-12"></a>    <span class="p">&lt;</span><span class="nt">p</span><span class="p">&gt;</span>
<a name="python--ex52--gothonweb--templates--show_room.html-pyg.html-13"></a>    <span class="p">&lt;</span><span class="nt">form</span> <span class="na">action</span><span class="o">=</span><span class="s">&quot;/game&quot;</span> <span class="na">method</span><span class="o">=</span><span class="s">&quot;POST&quot;</span><span class="p">&gt;</span>
<a name="python--ex52--gothonweb--templates--show_room.html-pyg.html-14"></a>        - <span class="p">&lt;</span><span class="nt">input</span> <span class="na">type</span><span class="o">=</span><span class="s">&quot;text&quot;</span> <span class="na">name</span><span class="o">=</span><span class="s">&quot;action&quot;</span><span class="p">&gt;</span> <span class="p">&lt;</span><span class="nt">input</span> <span class="na">type</span><span class="o">=</span><span class="s">&quot;SUBMIT&quot;</span><span class="p">&gt;</span>
<a name="python--ex52--gothonweb--templates--show_room.html-pyg.html-15"></a>    <span class="p">&lt;/</span><span class="nt">form</span><span class="p">&gt;</span>
<a name="python--ex52--gothonweb--templates--show_room.html-pyg.html-16"></a>    <span class="p">&lt;/</span><span class="nt">p</span><span class="p">&gt;</span>
</pre></div><p>That is the template to show a room as you travel through the game. Next you need one to tell someone they died in the case that they got to the end of the map on accident, which is <tt class="docutils literal">templates/you_died.html</tt>:</p>
<div class="highlight"><pre><span></span><a name="python--ex52--gothonweb--templates--you_died.html-pyg.html-1"></a><span class="p">&lt;</span><span class="nt">h1</span><span class="p">&gt;</span>You Died!<span class="p">&lt;/</span><span class="nt">h1</span><span class="p">&gt;</span>
<a name="python--ex52--gothonweb--templates--you_died.html-pyg.html-2"></a>
<a name="python--ex52--gothonweb--templates--you_died.html-pyg.html-3"></a><span class="p">&lt;</span><span class="nt">p</span><span class="p">&gt;</span>Looks like you bit the dust.<span class="p">&lt;/</span><span class="nt">p</span><span class="p">&gt;</span>
<a name="python--ex52--gothonweb--templates--you_died.html-pyg.html-4"></a><span class="p">&lt;</span><span class="nt">p</span><span class="p">&gt;&lt;</span><span class="nt">a</span> <span class="na">href</span><span class="o">=</span><span class="s">&quot;/&quot;</span><span class="p">&gt;</span>Play Again<span class="p">&lt;/</span><span class="nt">a</span><span class="p">&gt;&lt;/</span><span class="nt">p</span><span class="p">&gt;</span>
</pre></div><p>With those in place, you should now be able to do the following:</p>
<ol class="arabic simple">
<li>Get the test <tt class="docutils literal">tests/app_tests.py</tt> working again so that you are testing the game.  You won't be able to do much more than a few clicks in the game because of sessions, but you should be able to do some basics.</li>
<li>Remove the <tt class="docutils literal">sessions/*</tt> files and make sure you've started over.</li>
<li>Run the <tt class="docutils literal">python bin/app.py</tt> script and test out the game.</li>
</ol>
<p>You should be able to refresh and fix the game like normal, and work with the game HTML and engine until it does all the things you want it to do.</p>
</div>
<div class="section" id="your-final-exam">
<h1>Your Final Exam</h1>
<p>Do you feel like this was a huge amount of information thrown at you all at once?  Good, I want you to have something to tinker with while you build your skills.  To complete this exercise, I'm going to give you a final set of exercises for you to complete on your own.  You'll notice that what you've written so far isn't very well built; it is just a first version of the code.  Your task now is to make the game more complete by doing these things:</p>
<ol class="arabic simple">
<li>Fix all the bugs I mention in the code, and any that I didn't mention.  If you find new bugs, let me know.</li>
<li>Improve all of the automated tests so that you test more of the application and get to a point where you use a test rather than your browser to check the application while you work.</li>
<li>Make the HTML look better.</li>
<li>Research logins and create a signup system for the application, so people can have logins and high scores.</li>
<li>Complete the game map, making it as large and feature-complete as possible.</li>
<li>Give people a &quot;help&quot; system that lets them ask what they can do at each room in the game.</li>
<li>Add any other features you can think of to the game.</li>
<li>Create several &quot;maps&quot; and let people choose a game they want to run.  Your <tt class="docutils literal">bin/app.py</tt> engine should be able to run any map of rooms you give it, so you can support multiple games.</li>
<li>Finally, use what you learned in Exercises 48 and 49 to create a better input processor. You have most of the code necessary; you just need to improve the grammar and hook it up to your input form and the <tt class="docutils literal">GameEngine</tt>.</li>
</ol>
<p>Good luck!</p>
</div>
<div class="section" id="common-student-questions">
<h1>Common Student Questions</h1>
<dl class="docutils">
<dt>I'm using <tt class="docutils literal">sessions</tt> in my game and I can't test it with <tt class="docutils literal">nosetests</tt>.</dt>
<dd>You need to read about sessions in the reloader <a class="reference external" href="http://webpy.org/cookbook/session_with_reloader">http://webpy.org/cookbook/session_with_reloader</a>.</dd>
<dt>I get an <tt class="docutils literal">ImportError</tt>.</dt>
<dd>Wrong directory. Wrong Python version. <tt class="docutils literal">PYTHONPATH</tt> not set. No <tt class="docutils literal">__init__.py</tt> file. Spelling mistake in import.</dd>
</dl>
</div>
                <!-- RST ENDS -->
            </div>
        </div>

        <div class="row center-xs" id="buy">
            <div class="text-center col-xs-10 col-sm-5 col-md-4">
                <h2 class="section-title__small">Buy The Python 2 Course</h2>
                <p>
                When you buy directly from the author, Zed A. Shaw, you'll get a professional
                quality PDF and  hours of HD Video, all DRM-free and yours to download.
                </p>

                <p class="price-block">
                <span class="currency"><span class="prefix">$</span>29.<span class="suffix">99</span></span>
                </p>

                <a href="https://shop.learncodethehardway.org/access/buy/2/" class="btn btn-primary btn-full">Buy The Python 2 Course</a>
                <a href="https://shop.learncodethehardway.org/access/buy/9/" class="btn btn-primary btn-full">Pre-Order The Python 3 Course Instead</a>

                <p class="text-left btn-subtext">
                <small>Or, you can <a href="https://learnpythonthehardway.org/book/book_2.html">read Learn Python the Hard Way for free</a> right here, video lectures not included.</small>
                </p>

            </div>
            <div class="text-center col-xs-10 col-sm-5 col-md-4 col-sm-offset-1">

                <h2 class="section-title__small">Other Buying Options</h2>
                <a href="http://bit.ly/amznlpthw" class="btn btn-secondary btn-full">Buy on Amazon</a>
                <a href="http://bit.ly/informitlpthw" class="btn btn-secondary btn-full">Buy a hard copy from the Publisher</a>
                <a href="http://bit.ly/bnlpthw" class="btn btn-secondary btn-full">Buy a hard copy from Barnes &amp; Noble</a>

            </div>
        </div>
    </div>

    <div class="row center-xs" id="video_holder" style="display: none">
        <div class="col-xs-11 col-sm-10 col-md-9 col-lg-8">
            <div data-paydiv_product="2" id='paydiv'>
                No content available for this exercise.  You can view all available downloads at <a href="https://shop.learncodethehardway.org/customers/">your customer account page</a>.
            </div>
        </div>
    </div>
    </main>

</div>

<div class="row dark bottom-nav">
    <div class="col-xs text-left">
        <a href="ex52.html" class="prev" id='prev_link'><i class="icon-arrow-67"></i> <i class="icon icon-arrow-left"></i> Previous <span class="hide-xs show-sm-inline">Lesson</span></a>
    </div>
    <div class="col-xs text-right"><a href="ex52.html" class="next" id='next_link'>Next <span class="hide-xs show-sm-inline">Lesson</span> <i class="icon icon-arrow-right"></i></a>
    </div>
</div>
  </div>

<footer class="footer">
<div class="row center-xs">

    <div class="col-xs-11 col-sm-6 col-md-5 col-lg-5">
        <ul class="nav nav-inline">
            <li><h4><a href="https://learnpythonthehardway.org/learnpythonthehardway_default_2.html">Home</a></h4></li>
            <li><h4><a href="https://learncodethehardway.org/about/">About</a></h4></li>
            <li><h4><a href="https://learncodethehardway.org/contact/">Contact</a></h4></li>
        </ul>
        <div class="copyright text-left">
            <small class="text-muted">&copy; 2016 Zed A. Shaw. All rights reserved.</small>
        </div>
    </div>
    <div class="col-xs-11 col-sm-4 col-md-4 col-lg-3">
        <div class="social-media">
            <div class="classy-container">
                <a href="https://twitter.com/lzsthw" class="socicon-twitter"></a>
            </div>
        </div>
    </div>
</div>

</footer>
<script src="../js/scripts.min.js"></script>

<script src="javascripts/jquery.js"></script>
<script src="index.js"></script>
<script src="https://shop.learncodethehardway.org/static/jzed.js"></script>
<script src="https://shop.learncodethehardway.org/static/js/videojs/video.js"></script>
<link rel="stylesheet" href="https://shop.learncodethehardway.org/static/js/videojs/video-js.css">
<script src="https://shop.learncodethehardway.org/static/api/v1/paydiv.js"></script>
<script src="javascripts/app.js"></script>
<script src="javascripts/littools.js"></script>
<!-- Start of helpthw Zendesk Widget script -->
<script>/*<![CDATA[*/window.zEmbed||function(e,t){var n,o,d,i,s,a=[],r=document.createElement("iframe");window.zEmbed=function(){a.push(arguments)},window.zE=window.zE||window.zEmbed,r.src="javascript:false",r.title="",r.role="presentation",(r.frameElement||r).style.cssText="display: none",d=document.getElementsByTagName("script"),d=d[d.length-1],d.parentNode.insertBefore(r,d),i=r.contentWindow,s=i.document;try{o=s}catch(e){n=document.domain,r.src='javascript:var d=document.open();d.domain="'+n+'";void(0);',o=s}o.open()._l=function(){var o=this.createElement("script");n&&(this.domain=n),o.id="js-iframe-async",o.src=e,this.t=+new Date,this.zendeskHost=t,this.zEQueue=a,this.body.appendChild(o)},o.write('<body onload="document._l();">'),o.close()}("https://assets.zendesk.com/embeddable_framework/main.js","helpthw.zendesk.com");
/*]]>*/</script>
<!-- End of helpthw Zendesk Widget script -->
<script>
(function(i,s,o,g,r,a,m){i['GoogleAnalyticsObject']=r;i[r]=i[r]||function(){
 (i[r].q=i[r].q||[]).push(arguments)},i[r].l=1*new Date();a=s.createElement(o),
 m=s.getElementsByTagName(o)[0];a.async=1;a.src=g;m.parentNode.insertBefore(a,m)
 })(window,document,'script','https://www.google-analytics.com/analytics.js','ga');

ga('create', 'UA-24168052-1', 'auto');
ga('send', 'pageview');

</script>

</body>
</html>
